routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\DisplayController;
use App\Http\Controllers\ShowController;
use App\Http\Controllers\InventoryController;
use App\Http\Controllers\FileController;
use App\Http\Controllers\HelpController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\GroupController;
use App\Http\Controllers\OrganizationController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\RegistrationController;
use App\Http\Controllers\LoginController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect()->route('login');
});
Route::get('/about', function(){
    return view('about');
})->name('about');

Route::group(['middleware' => config('fortify.middleware', ['web'])], function () {
    $limiter = config('fortify.limiters.login');

    Route::post('/login', [LoginController::class, 'store'])
        ->middleware(array_filter([
            'guest',
            $limiter ? 'throttle:'.$limiter : null,
        ]));
    Route::post('/register', [RegistrationController::class, 'store'])->middleware(['guest']);
});

Route::get('/terms',function(){
    return view('terms');
})->name('terms');

Route::middleware(['auth:sanctum', 'verified'])->group(function(){
    Route::get('/dashboard', [DashboardController::class, 'index'])->name('dashboard');
    
    // Display Routes
    Route::prefix('displays')->group(function(){
        Route::get('/', [DisplayController::class, 'index'])->name('displays');
        Route::post('/', [DisplayController::class, 'create']);
        Route::post('search/{search?}', [DisplayController::class, 'search']);
        Route::get('/{display}', [DisplayController::class, 'show']);
        Route::delete('/{display}', [DisplayController::class, 'delete']);
        Route::post('/{display}/registrations', [DisplayController::class, 'register']);
        Route::delete('/{display}/registrations/{registration}', [DisplayController::class, 'unregister']);
    });
    Route::prefix('shows')->group(function(){
        Route::get('/', [ShowController::class, 'index'])->name('show');
        Route::post('/',[ShowController::class, 'store']);
        Route::post('search/{search?}', [ShowController::class, 'search']);
        Route::get('/{show}', [ShowController::class, 'show']);
        Route::put('/{show}', [ShowController::class, 'update']);
        Route::post('/{show}/display/{display}', [ShowController::class, 'deploy']);
        Route::delete('/{show}/display/{display}', [ShowController::class, 'deleteDeployment']);
    });
    Route::prefix('inventory')->group(function(){
        Route::get('/', [InventoryController::class, 'index'])->name('inventory');
        Route::post('search/{search?}', [DisplayController::class, 'search']);

    });
    Route::prefix('files')->group(function(){
        Route::get('/', [FileController::class, 'index'])->name('files');
        Route::post('/', [FileController::class, 'store']);
        Route::post('{user}/', [FileController::class, 'uploadUser']);
        // Organization/Group files
        Route::post('group/{group}/{path}',[FileController::class, 'uploadGroup'])->where('group','[0-9]+')->where('path', '.*');
        Route::get('group/{group}/{path?}',[FileController::class, 'showGroup'])->where('group','[0-9]+')->where('path', '.*');
        Route::put( 'group/{group}/{path}',[FileController::class, 'updateGroup'])->where('group','[0-9]+')->where('path', '.*');
        // User Files
        Route::post('user/{user}/{path}',[FileController::class, 'uploadUser'])->where('path', '.*');
        Route::get('user/{user}/{path?}',[FileController::class, 'showUser'])->where('user','[0-9]+')->where('path', '.*');
        Route::put('user/{user}/{path}', [FileController::class, 'updateUser'])->where('user','[0-9]+')->where('path', '.*');

    });
    Route::prefix('user')->group(function(){
        Route::put('organization/{organization}', [UserController::class, 'changeOrganization']);

    });
    Route::prefix('users')->group(function(){
        Route::get('',  [UserController::class, 'index'])->name('users');
        Route::get('{user}', [UserController::class, 'show']);
        Route::post('', [UserController::class, 'store']);
        Route::post('search/{search?}', [UserController::class, 'search']);
    });
    Route::prefix('groups')->group(function(){
        Route::post('{group}/user/{user}', [GroupController::class, 'addUser']);
        Route::post('{group}/users', [GroupController::class, 'addUsers']);
        Route::delete('{group}/user/{user}', [GroupController::class, 'rmUser']);
        Route::delete('{group}/users', [GroupController::class, 'rmUsers']);
        Route::post('search/{search?}', [GroupController::class, 'search']);
        Route::post('/{group}/groups',   [GroupController::class, 'storeChild']);
    });
    Route::resource('groups', GroupController::class);
    Route::prefix('inventory')->group(function(){
        Route::get('/', [InventoryController::class, 'index'])->name('inventory');
    });
    Route::prefix('organizations')->group(function(){
        // Using group controller here since this is a generic group function
        Route::post(        '{organization}/users', [OrganizationController::class, 'addUsers']);
        Route::post(  '{organization}/user/{user}', [OrganizationController::class, 'addUser']);
        Route::delete(      '{organization}/users', [OrganizationController::class, 'rmUsers']);
        Route::delete('{organization}/user/{user}', [OrganizationController::class, 'rmUser']);
        Route::put(       '{organization}/feature', [OrganizationController::class, 'toggleFeature']);
        Route::post(            'search/{search?}', [OrganizationController::class, 'search']);
        Route::post(        '{organization}/group', [OrganizationController::class, 'storeGroup']);
    });
    Route::resource('organizations', OrganizationController::class);
    Route::resource('roles', RoleController::class);
});

Route::get('/help', [HelpController::class, 'help']);
Route::get('/help/{topic}', [HelpController::class, 'help']);
Route::get('/help/{topic}/{subtopic}', [HelpController::class, 'help']);

app/View/Components/GuestLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class GuestLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.guest');
    }
}

resources/views/about.blade.php
<x-guest-layout>
    <div class="py-4 px-12">
        <div class="max-w-7xl mx-auto px-4 sm:px-6 lg:px-8">
            <h2 class="text-2xl mb-3">About Vapor DGS</h2>
            <p class="mb-2">
                Vapor DGS stands for Visual Arts Portable Digital Graphics System.
                It is capable of displaying video, images, and websites on remotely controlled displays.
                It features automated or interactive shows that can operate without the need for internet.
            </p>
            <p class="mb-2">
                There is still a lot of work to do to get it to where we desire, but it is working right now.
                If you are interested in helping, please see the project on <a class="text-blue-600 dark:text-blue-400" href="https://gitlab.com/churchtechhelp/vapor/server" target="_BLANK">GitLab</a>.
            </p>
            <p class="mb-2">
                You can host your own Vapor server for free, but the hosted version will require payment.
            </p>
            <p>
                For more information, please check out the main website, <a class="text-blue-600 dark:text-blue-400" href="https://churchtech.help/resources/software/inhouse/vapor.html">ChurchTech.Help</a>.
            </p>
        </div>
    </div>
</x-guest-layout>

resources/views/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Vapor DGS') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <link rel="stylesheet" href="{{ mix('css/app.css') }}">

        <!-- Icons -->
        <link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png">
        <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
        <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
        <link rel="mask-icon" href="/safari-pinned-tab.svg" color="#5bbad5">
        <link rel="manifest" href="/site.webmanifest">
        <meta name="msapplication-TileColor" content="#ffc40d">
        <meta name="theme-color" content="#ffffff">

        <!-- Scripts -->
        <script src="{{ mix('js/app.js') }}" defer></script>
    </head>
    <body class="font-sans antialiased">
        @inertia
    </body>
</html>

resources/views/terms.blade.php
<x-guest-layout>
    <div class="px-24 py-12 bg-gray-200 min-h-screen">
        <div class="grid grid-cols-1 border border-black rounded justify-center px-2 py-1 bg-white">
            <div class="flex w-full justify-center">
                <img src="/logo-long.svg">
            </div>
            <div class="flex text-4xl font-bold justify-center">
                Vapor Licensing
            </div>
            <div class="block text-xl font-semibold mb-2">Code License</div>
            <div class="block mb-3 ml-2">
                The Visual Arts Portable Digital Graphics System, e.g. Vapor, is copywrighted under the GNU GPLv3 license.
                Under the terms of the GPL license, code must be available and may not be used in proprietary applications.
                The code for this project is available on <a href="https://gitlab.com/churchtechhelp/vapor/server">GitLab</a>.
            </div>
            <div class="block text-xl font-semibold mb-2">Terms and Conditions</div>
            <div class="ml-2">
                <div class="block mb-1">
                The following terms and conditions govern all use of the Vapor website (the "Website").
                The Website is offered subject to your acceptance without modification of all the terms and conditions
                contained herin and all other operating rules, policies, and procedures that may be published from time to time on this Website by Church Tech Help (collectively, the "Agreement").
                </div>
                <div class="block mb-1">
                Please read this Agreement carefully before accessing or using the Website.
                By accessing or using any part of the Website, you agree to be bound by the terms and conditions of this Agreement.
                If you do not agree to all the terms and conditions of this Agreement, then you may not access the Website or use any of the services.
                The Website is available only to individuals who are a part of a non-profit organization or church who are at least 13 years old.
                </div>
                <div class="mb-1 text-lg">Your Account Responsibilities</div>
                <div class="block mb-1 ml-2">
                If you create an account on this Website, you are responsible for maintaining the security of your account.
                You are responsible for all activites that occur under the account and any other actions taken in connection with the account.
                You must immediately notify Church Tech Help of any unauthorized use of your account or any other breaches of security.
                Church Tech Help will not be liable for any acts or omissions by You, including any damages of any kind incurred as a result of such acts or omissions.
                </div>
                <div class="mb-1 text-lg">Acceptible Use</div>
                <div class="block mb-1 ml-2">
                By accepting this Agreement you agree not to use, encourage, promote, or facilitate others to use
                the Website or your account in any way that is harmful to others.
                Examples of harmful use include, but are not limited to:
                <ul class="list-disc ml-6">
                    <li class="my-1">Engaging in illegal or fradulent activities.</li>
                    <li class="mb-1">Infringing upon others' intellectual property rights</li>
                    <li class="mb-1">Distributing harmful or offensive content that is defamatory, obscene, abusive, an invasion of privacy or harassing.</li>
                    <li class="mb-1">Distributing copywrighted content</li>
                    <li class="mb-1">Distributing malicious content or spam</li>
                    <li class="mb-1">Taxing Church Tech Help resources with activites such as cryptocurrency</li>
                </ul>
                </div>
                <div class="mb-1 text-lg">Privacy</div>
                <div class="block mb-1">
                Church Tech Help respects your privacy, but has not yet decided what measures or agreements to put in this Agreement.
                Site Administrators reserve the right to view or remove any content uploaded to the site, but will only
                do so if asked by the owner of the content or if suspicious activity warrants it.
                </div>
                <div class="block mb-1 ml-2">
                Church Tech Help leverages site analytics in order to improve the Website.
                </div>
                <div class="block mb-1 ml-2">
                If you are a part of the EU and wish to exercise your right of erasure, please email Church Tech Help.
                </div>
                <div class="mb-1 text-lg">Termination</div>
                <div class="block mb-1 ml-2">
                Church Tech Help may terminate your access to all or any part of the Website at any time, with or without cause, with or without notice, effective immediately.
                If you wish to terminate this Agreement or your GitLab account, you may simply discontinue using the Website.
                All provisions of this Agreement which by their nature should survive termination shall survive termination, including, without limitation, ownership provisions, warranty disclaimers, indemnity and limitations of liability.
                </div>
                <div class="mb-1 text-lg">Disclaimer of Warranty</div>
                <div class="block mb-1 ml-2">
                The Website is provided "as is".
                Church Tech Help makes no warranty that the Website will be error free or that access therto will be continuous or uninterrupted.
                </div>
            </div>
        </div>
    </div>
</x-guest-layout>